<template>
<div class="question">
  <h2>Question {{ index + 1 }}</h2>
  <p class="delete-question" @click="deleteQuestion">❌</p>
  <input type="text" placeholder="Intitulé de la question" v-model="question.title">
  <project-response v-for="(response, index) in question.responses" :key="index" :response="response" :index="index" @updateFields="updateResponseFields" @deleteAnswer="removeResponse"/>
  <p @click="addResponse" class="add-response">➕ Ajouter une réponse</p>
</div>
</template>

<script>
import ProjectResponse from '@/components/ProjectResponse'
export default {
  name: 'ProjectQuestion',
  components: { ProjectResponse },
  props: {
    question: {
      type: Object,
      default: () => {
        return {}
      }
    },
    index: {
      type: Number,
      default: 0
    }
  },
  methods: {
    updateResponseFields: function (params) {
      this.question.responses[params.index] = params.response
    },
    addResponse: function () {
      const defaultResponse = {
        num_response: this.question.responses.length,
        response: '',
        scene: ''
      }
      this.question.responses.push(defaultResponse)
    },
    removeResponse: function (index) {
      this.question.responses.splice(index, 1)
    },
    deleteQuestion: function () {
      this.$emit('removeQuestion', this.index)
    }
  }
}
</script>

<style scoped lang="scss">
  .question {
    margin: 1em 0 3em 0;
    border: 1px solid #AAAAAA;
    border-radius: 6px;
    box-shadow: 0 13px 40px 0 rgba(0, 0, 0, 0.18);
    position: relative;
    padding: 1em;
    .add-button {
      max-width: 8em;
    }
    .delete-question {
      position: absolute;
      top: 0;
      right: 1em;
      cursor: pointer;
      transition: .5s transform;
      &:hover {
        transform: scale(1.25);
        transition: .5s transform;
      }
    }
    input {
      width: 100%;
      box-sizing: border-box;
      font-size: 1.2em;
      padding: .5em 1em;
      border: 1px solid #535353;
      border-radius: 6px;
    }
    .add-response {
      cursor: pointer;
    }
  }
</style>
